diff -uwr sourceold/scripts/engine_obj.cpp source/scripts/engine_obj.cpp
--- sourceold/scripts/engine_obj.cpp	2012-02-17 21:03:32.721679600 +0800
+++ source/scripts/engine_obj.cpp	2012-05-23 11:24:04.913085900 +0800
@@ -1242,19 +719,24 @@
 
 void SCRIPTS_API Send_Custom_All_Objects(int type,GameObject *sender,int team)
 {
-	if (!Commands->Get_ID(sender) || !sender)
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x) 
 	{
-		GameObject *obj = (GameObject *)x->Data();
-		if (obj && As_ScriptableGameObj(obj))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if ((Get_Object_Type(obj) == team) || (team == 2))
+			if ((Get_Object_Type(o2) == team) || (team == 2))
 			{
-				Commands->Send_Custom_Event(sender,obj,type,0,0);
+				Commands->Send_Custom_Event(sender,o2,type,0,0);
 			}
 		}
 		x = x->Next();
@@ -1263,20 +745,25 @@
 
 void SCRIPTS_API Send_Custom_Event_To_Object(GameObject *sender,const char *Preset,int type,int param,float delay)
 {
-	if (!Commands->Get_ID(sender) || !sender)
+	if (!sender)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o2->Get_Definition();
 			if (!_stricmp(d->Get_Name(),Preset))
 			{
-				Commands->Send_Custom_Event(sender,o,type,param,delay);
+				Commands->Send_Custom_Event(sender,o2,type,param,delay);
 			}
 		}
 		x = x->Next();
@@ -1288,19 +775,24 @@
 	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			if (Get_Object_Type(o) == team && !_stricmp(Commands->Get_Preset_Name(o),preset))
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			if (Get_Object_Type(o2) == team && !_stricmp(Commands->Get_Preset_Name(o2),preset))
 			{
-				Vector3 pos = Commands->Get_Position(o);
+				Vector3 pos = Commands->Get_Position(o2);
 				pos.Z = 0;
 				location.Z = 0;
 				if (Commands->Get_Distance(pos,location) <= range)
 				{
-					if (As_VehicleGameObj(o) && !empty)
+					if (o2->As_VehicleGameObj() && !empty)
 					{
-						if (o->As_VehicleGameObj()->Get_Occupant_Count() == 0)
+						if (o2->As_VehicleGameObj()->Get_Occupant_Count() == 0)
 						{
 							return false;
 						}
@@ -1323,45 +815,57 @@
 
 bool SCRIPTS_API Get_Is_Powerup_Persistant(GameObject *obj)
 {
-	PowerUpGameObj *o = (PowerUpGameObj *)As_PowerUpGameObj(obj);
+	if (obj->As_PhysicalGameObj())
+	{
+		PowerUpGameObj *o = obj->As_PhysicalGameObj()->As_PowerUpGameObj();
 	if (!o)
 	{
 		return 0;
 	}
 	return o->Get_Definition().Is_Persistant();
 }
+	return 0;
+}
 
 bool SCRIPTS_API Get_Powerup_Always_Allow_Grant(GameObject *obj)
 {
-	PowerUpGameObj *o = (PowerUpGameObj *)As_PowerUpGameObj(obj);
+	if (obj->As_PhysicalGameObj())
+	{
+		PowerUpGameObj *o = obj->As_PhysicalGameObj()->As_PowerUpGameObj();
 	if (!o)
 	{
 		return 0;
 	}
 	return o->Get_Definition().Is_Always_Allow_Grant();
 }
+	return 0;
+}
 
 int SCRIPTS_API Get_Powerup_Grant_Sound(GameObject *obj)
 {
-	PowerUpGameObj *o = (PowerUpGameObj *)As_PowerUpGameObj(obj);
+	if (obj->As_PhysicalGameObj())
+	{
+		PowerUpGameObj *o = obj->As_PhysicalGameObj()->As_PowerUpGameObj();
 	if (!o)
 	{
 		return 0;
 	}
 	return o->Get_Definition().Get_Grant_Sound();
 }
+	return 0;
+}
 
 void SCRIPTS_API Grant_Powerup(GameObject *obj,const char *Preset_Name)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	GameObject *o = As_SmartGameObj(obj);
+	SmartGameObj *o = obj->As_SmartGameObj();
 	if (o)
 	{
 		PowerUpGameObjDef *def = (PowerUpGameObjDef *)Find_Named_Definition(Preset_Name);
-		def->Grant((SmartGameObj *)o,0,true);
+		def->Grant(o,0,true);
 	}
 }
 
@@ -1426,17 +930,22 @@
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
-		GameObject *o = (GameObject *)x->Data();
-		if (o && As_ScriptableGameObj(o) && o != obj)
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o && o != obj)
+		{
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 		{
-			if ((team == 2 || Get_Object_Type(o) == team) && Is_Armed(o))
+			if ((team == 2 || Get_Object_Type(o2) == team) && o2->As_PhysicalGameObj() && o2->As_PhysicalGameObj()->As_ArmedGameObj())
 			{
-				Vector3 pos = Commands->Get_Position(o);
+				Vector3 pos = Commands->Get_Position(o2);
 				float dist = Commands->Get_Distance(pos,position);
 				if (dist < closestdist)
 				{
 					closestdist = dist;
-					closest = o;
+					closest = o2;
 				}
 			}
 		}
@@ -1445,27 +954,6 @@
 	return closest;
 }
 
-void SCRIPTS_API Set_Powerup_Always_Allow_Grant(GameObject *obj,bool Grant)
-{
-	if (!Commands->Get_ID(obj) || !obj)
-	{
-		return;
-	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
-	if (!o2)
-	{
-		return;
-	}
-	PowerUpGameObj *o3 = o2->As_PowerUpGameObj();
-	if (!o3)
-	{
-		return;
-	}
-	((PowerUpGameObjDef&)o3->Get_Definition()).AlwaysAllowGrant = Grant;
-}
-
-
-
 void PhysicalGameObj::Set_Transform(const Matrix3D& mat)
 {
 	PhysObj->Set_Transform(mat);
@@ -1484,7 +972,7 @@
 	PhysObj->Set_Transform(tm);
 }
 
-bool DamageableGameObj::Is_Teammate(DamageableGameObj * p_obj)
+SCRIPTS_API bool DamageableGameObj::Is_Teammate(DamageableGameObj * p_obj)
 {
 	return ((p_obj == this) || (Is_Team_Player() && Get_Player_Type() == p_obj->Get_Player_Type()));
 }
@@ -1516,13 +1004,13 @@
 	return NULL;
 }
 
-bool DamageableGameObj::Is_Team_Player(void) 
+SCRIPTS_API bool DamageableGameObj::Is_Team_Player(void) 
 {
 	int player_type = Get_Player_Type();
 	return player_type == PLAYERTYPE_NOD || player_type == PLAYERTYPE_GDI;
 }
 
-bool DamageableGameObj::Is_Enemy(DamageableGameObj *obj)
+SCRIPTS_API bool DamageableGameObj::Is_Enemy(DamageableGameObj *obj)
 {
 	bool enemy = false;
 	if (obj != this)
@@ -1548,7 +1036,7 @@
 	return enemy;
 }
 
-AnimControlClass *PhysicalGameObj::Get_Anim_Control()
+SCRIPTS_API AnimControlClass *PhysicalGameObj::Get_Anim_Control()
 {
 	return AnimControl;
 }
@@ -1558,12 +1046,12 @@
 	*Position = Peek_Physical_Object()->Get_Transform().Get_Translation();
 }
 
-const PowerUpGameObjDef & PowerUpGameObj::Get_Definition( void ) const
+SCRIPTS_API  const PowerUpGameObjDef & PowerUpGameObj::Get_Definition( void ) const
 {
 	return (const PowerUpGameObjDef &)BaseGameObj::Get_Definition();
 }
 
-const PhysicalGameObjDef & PhysicalGameObj::Get_Definition( void ) const
+SCRIPTS_API  const PhysicalGameObjDef & PhysicalGameObj::Get_Definition( void ) const
 {
 	return (const PhysicalGameObjDef &)BaseGameObj::Get_Definition();
 }
@@ -1583,4 +1071,28 @@
 	}
 	return false;
 }
+
+void SCRIPTS_API Set_Powerup_Always_Allow_Grant(GameObject *obj,bool Grant)
+{
+	if (!obj)
+	{
+		return;
+	}
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
+	if (!o2)
+	{
+		return;
+	}
+	PowerUpGameObj *o3 = o2->As_PowerUpGameObj();
+	if (!o3)
+	{
+		return;
+	}
+	((PowerUpGameObjDef&)o3->Get_Definition()).AlwaysAllowGrant = Grant;
+}
+
+void SCRIPTS_API PhysicalGameObj::Set_Collision_Group(int group)
+{
+	PhysObj->Set_Collision_Group((Collision_Group_Type)group);
+}
 #endif
\ No newline at end of file
diff -uwr sourceold/scripts/engine_obj.h source/scripts/engine_obj.h
--- sourceold/scripts/engine_obj.h	2011-10-11 21:54:59.320312500 +0800
+++ source/scripts/engine_obj.h	2012-04-24 13:38:29.723632800 +0800
@@ -50,39 +50,6 @@
 
 int SCRIPTS_API Get_Object_Type(GameObject *obj); //get the team of an object,0 = Nod,1 = GDI,2 = neutral,works on buildings
 void SCRIPTS_API Set_Object_Type(GameObject *obj,int type); //set the team of an object,0 = Nod,1 = GDI,2 = neutral,works on buildings
-GameObject SCRIPTS_API *As_ArmedGameObj(GameObject *obj); //Check if object is an ArmedGameObj
-GameObject SCRIPTS_API *As_BeaconGameObj(GameObject *obj); //Check if object is a BeaconGameObj
-GameObject SCRIPTS_API *As_C4GameObj(GameObject *obj); //Check if object is a C4GameObj
-GameObject SCRIPTS_API *As_ScriptableGameObj(GameObject *obj); //Check if object is a ScritableGameObj
-GameObject SCRIPTS_API *As_VehicleGameObj(GameObject *obj); //Check if object is a VehicleGameObj
-GameObject SCRIPTS_API *As_SoldierGameObj(GameObject *obj); //Check if object is a SoldierGameObj
-GameObject SCRIPTS_API *As_BuildingGameObj(GameObject *obj); //Check if object is a BuildingGameObj
-GameObject SCRIPTS_API *As_SmartGameObj(GameObject *obj); //Check if object is a SmartGameObj
-GameObject SCRIPTS_API *As_PhysicalGameObj(GameObject *obj); //Check if object is a PhysicalGameObj
-GameObject SCRIPTS_API *As_DamageableGameObj(GameObject *obj); //Check if object is a DamageableGameObj
-GameObject SCRIPTS_API *As_ScriptZoneGameObj(GameObject *obj); //Check if object is a ScriptZoneGameObj
-GameObject SCRIPTS_API *As_VehicleFactoryGameObj(GameObject *obj); //Check of object is a VehicleFactoryGameObj
-bool SCRIPTS_API Is_Building(GameObject *obj); //is a BuildingGameObj
-bool SCRIPTS_API Is_Soldier(GameObject *obj); //is a SoldierGameObj
-bool SCRIPTS_API Is_Vehicle(GameObject *obj); //is a VechicleGameObj
-bool SCRIPTS_API Is_Cinematic(GameObject *obj); //is a CinematicGameObj
-bool SCRIPTS_API Is_ScriptZone(GameObject *obj); //is a ScriptZoneGameObj
-bool SCRIPTS_API Is_Powerup(GameObject *obj); //is a PowerUpGameObj
-bool SCRIPTS_API Is_C4(GameObject *obj); //is a C4GameObj
-bool SCRIPTS_API Is_Beacon(GameObject *obj); //is a BeaconGameObj
-bool SCRIPTS_API Is_Armed(GameObject *obj); //is an ArmedGameObj
-bool SCRIPTS_API Is_Simple(GameObject *obj); //is a SimpleGameObj
-bool SCRIPTS_API Is_PowerPlant(GameObject *obj); //is a PowerPlantGameObj
-bool SCRIPTS_API Is_ConstructionYard(GameObject *obj); //is a ConstructionYardGameObj
-bool SCRIPTS_API Is_SoldierFactory(GameObject *obj); //is a SoldierFactoryGameObj
-bool SCRIPTS_API Is_VehicleFactory(GameObject *obj); //is a VehicleFactoryGameObj
-bool SCRIPTS_API Is_Airstrip(GameObject *obj); //is an AirstripGameObj
-bool SCRIPTS_API Is_WarFactory(GameObject *obj); //is a WarFactoryGameObj
-bool SCRIPTS_API Is_Refinery(GameObject *obj); //is a RefineryGameObj
-bool SCRIPTS_API Is_ComCenter(GameObject *obj); //is a ComCenterGameObj
-bool SCRIPTS_API Is_RepairBay(GameObject *obj); //is a RepairBayGameObj
-bool SCRIPTS_API Is_Scriptable(GameObject *obj); //is a ScriptableGameObj
-const char SCRIPTS_API *Get_Building_Type(GameObject *obj); //returns a string indicating the building type of an object
 void SCRIPTS_API Get_Object_Color(GameObject *obj, unsigned int *red, unsigned int *green, unsigned int *blue); //get color for a player
 GameObject SCRIPTS_API *Find_Smart_Object_By_Team(int Team); //will find the first SmartGameObj (i.e. soldier or vechicle) for the team,0 = Nod,1 = GDI
 GameObject SCRIPTS_API *Find_Object_By_Team(int Team); //will find the first object for the team,0 = Nod,1 = GDI
diff -uwr sourceold/scripts/engine_obj2.cpp source/scripts/engine_obj2.cpp
--- sourceold/scripts/engine_obj2.cpp	2012-02-13 18:26:42.375398400 +0800
+++ source/scripts/engine_obj2.cpp	2012-05-23 11:29:54.504882800 +0800
@@ -26,6 +26,7 @@
 #include "AirFactoryGameObj.h"
 #include "AirFactoryGameObjDef.h"
 #include "VehicleFactoryGameObjDef.h"
+#include "NavalFactoryGameObj.h"
 
 RENEGADE_FUNCTION
 GameObject *Create_Library_Object(const char *preset)
@@ -44,6 +45,22 @@
 bool AirFactoryGameObj::Is_Available_For_Purchase() const
 AT2(0x0070B6F0,0x0070ACB0);
 RENEGADE_FUNCTION
+SCRIPTS_API bool SoldierGameObj::Is_In_Elevator()
+AT2(0x006C9610,0x006C8EB0);
+RENEGADE_FUNCTION
+void NavalFactoryGameObj::Create_Vehicle(int defintion_id,SoldierGameObj * player)
+AT2(0x0073EE30,0x0073E6D0);
+RENEGADE_FUNCTION
+int NavalFactoryGameObj::Get_Team_Vehicle_Count() const
+AT2(0x0073FB80,0x0073F420);
+RENEGADE_FUNCTION
+bool NavalFactoryGameObj::Is_Available_For_Purchase() const
+AT2(0x007408E0,0x00740180);
+RENEGADE_FUNCTION
+bool NavalFactoryGameObj::Can_Spawn(int definition_id)
+AT2(0x007425B0,0x00741E50);
+
+RENEGADE_FUNCTION
 bool VehicleFactoryGameObj::Request_Vehicle(int defintion_id, float generation_time,SoldierGameObj * player)
 AT2(0x006EE1A0,0x006ED760);
 RENEGADE_FUNCTION
@@ -60,14 +77,9 @@
 {
 	float closest = 999999;
 	ScriptZoneGameObj *closestzone = 0;
-	for (SLNode<BaseGameObj>* node = GameObjManager::GameObjList.Head(); node; node = node->Next())
-	{
-		ScriptableGameObj* object = ((BaseGameObj *)node->Data())->As_ScriptableGameObj();
-		if (object)
-		{
-			ScriptZoneGameObj *zone = object->As_ScriptZoneGameObj();
-			if (zone)
+	for (SLNode<ScriptZoneGameObj>* node = GameObjManager::ScriptZoneGameObjList.Head(); node; node = node->Next())
 			{
+		ScriptZoneGameObj *zone = node->Data();
 				if (zone->Get_Definition().Get_Type() == Type)
 				{
 					float distance = Vector3::Distance(zone->Get_Bounding_Box().Center,Location);
@@ -78,8 +90,6 @@
 					}
 				}
 			}
-		}
-	}
 	return closestzone;
 }
 bool ScriptZoneGameObj::Inside_Me(PhysicalGameObj *obj)
@@ -100,23 +110,22 @@
 AT2(0x00470AC0,0x00470230);
 GameObject SCRIPTS_API *Find_Closest_Zone(Vector3 &location,unsigned int type)
 {
-	return (GameObject *)ScriptZoneGameObj::Find_Closest_Zone(location,(ZoneConstants::ZoneType)type);
+	return ScriptZoneGameObj::Find_Closest_Zone(location,(ZoneConstants::ZoneType)type);
 }
 
 GameObject SCRIPTS_API *Get_Vehicle(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (o)
 	{
 		GameObject *vehicle = o->Get_Vehicle();
-		if (vehicle)
+		if (vehicle && vehicle->As_VehicleGameObj())
 		{
-			GameObject *v = As_VehicleGameObj(vehicle);
-			return v;
+			return vehicle;
 		}
 		return 0;
 	}
@@ -125,11 +134,11 @@
 
 void SCRIPTS_API Grant_Refill(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	GameObject *o = As_SoldierGameObj(obj);
+	GameObject *o = obj->As_SoldierGameObj();
 	if (o)
 	{
 		GrantSupplies(obj);
@@ -138,7 +147,7 @@
 
 bool SCRIPTS_API Change_Character(GameObject *obj,const char *Preset_Name)
 {
-	if (!Commands->Get_ID(obj) || !obj || Get_Vehicle(obj))
+	if (!obj || Get_Vehicle(obj))
 	{
 		return false;
 	}
@@ -171,6 +180,10 @@
 	{
 		return factory->As_BuildingGameObj()->As_AirFactoryGameObj()->Is_Available_For_Purchase();
 	}
+	else if (factory->As_BuildingGameObj() && factory->As_BuildingGameObj()->As_NavalFactoryGameObj())
+	{
+		return factory->As_BuildingGameObj()->As_NavalFactoryGameObj()->Is_Available_For_Purchase();
+	}
 	else
 	{
 		return false;
@@ -179,11 +192,11 @@
 
 void SCRIPTS_API Toggle_Fly_Mode(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (o)
 	{
 		o->Toggle_Fly_Mode();
@@ -193,21 +206,21 @@
 
 int SCRIPTS_API Get_Vehicle_Occupant_Count(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	return o->Get_Occupant_Count();
 }
 
 GameObject SCRIPTS_API *Get_Vehicle_Occupant(GameObject *obj,int seat)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	if (seat >= o->Get_Definition().Get_Seat_Count())
 	{
 		return 0;
@@ -217,42 +230,42 @@
 
 GameObject SCRIPTS_API *Get_Vehicle_Driver(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	return o->Get_Driver();
 }
 
 GameObject SCRIPTS_API *Get_Vehicle_Gunner_Pos(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	return o->Get_Gunner();
 }
 
 GameObject SCRIPTS_API *Get_Vehicle_Gunner(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	return o->Get_Actual_Gunner();
 }
 
 #ifndef SHADERS_EXPORTS
 void SCRIPTS_API Force_Occupant_Exit(GameObject *obj,int seat)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	if (seat >= o->Get_Definition().Get_Seat_Count())
 	{
 		return;
@@ -267,11 +280,11 @@
 
 void SCRIPTS_API Force_Occupants_Exit(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	int x = o->Get_Definition().Get_Seat_Count();
 	ActionParamsStruct params;
 	params.Set_Basic((long)0,100,39);
@@ -286,7 +299,7 @@
 
 void SCRIPTS_API Soldier_Transition_Vehicle(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_SoldierGameObj(obj))
+	if (!obj || !obj->As_SoldierGameObj())
 	{
 		return;
 	}
@@ -297,11 +310,11 @@
 
 void SCRIPTS_API Force_Occupants_Exit_Team(GameObject *obj,int team)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	int x = o->Get_Definition().Get_Seat_Count();
 	ActionParamsStruct params;
 	params.Set_Basic((long)0,100,39);
@@ -317,18 +330,17 @@
 
 GameObject SCRIPTS_API *Get_Vehicle_Return(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return obj;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (o)
 	{
 		GameObject *vehicle = o->Get_Vehicle();
-		if (vehicle)
+		if (vehicle && vehicle->As_VehicleGameObj())
 		{
-			GameObject *v = As_VehicleGameObj(vehicle);
-			return v;
+			return vehicle;
 		}
 		return obj;
 	}
@@ -337,11 +349,11 @@
 
 bool SCRIPTS_API Get_Fly_Mode(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return false;
@@ -351,11 +363,11 @@
 
 bool SCRIPTS_API Is_Stealth(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	SmartGameObj *o = (SmartGameObj *)As_SmartGameObj(obj);
+	SmartGameObj *o = obj->As_SmartGameObj();
 	if (!o)
 	{
 		return false;
@@ -365,21 +377,21 @@
 
 int SCRIPTS_API Get_Vehicle_Seat_Count(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	return o->Get_Definition().Get_Seat_Count();
 }
 
 unsigned int SCRIPTS_API Get_Vehicle_Mode(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	GameObject *o = As_VehicleGameObj(obj);
+	GameObject *o = obj->As_VehicleGameObj();
 	if (!o)
 	{
 		obj = Get_Vehicle(obj);
@@ -388,7 +400,7 @@
 			return 0;
 		}
 	}
-	VehicleGameObjDef *d = (VehicleGameObjDef *)Get_Definition(obj);
+	const VehicleGameObjDef *d = &obj->As_VehicleGameObj()->Get_Definition();
 	return (int)d->Get_Type();
 }
 
@@ -399,11 +411,11 @@
 
 GameObject SCRIPTS_API *Get_Vehicle_Owner(GameObject *obj)
 {	
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	return o->Get_Lock_Owner();
 }
 
@@ -416,11 +428,11 @@
 
 OBBoxClass SCRIPTS_API *Get_Zone_Box(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	ScriptZoneGameObj *o = (ScriptZoneGameObj*)As_ScriptZoneGameObj(obj);
+	ScriptZoneGameObj *o = obj->As_ScriptZoneGameObj();
 	if (!o)
 	{
 		return 0;
@@ -430,11 +442,11 @@
 
 bool SCRIPTS_API PointInZone(GameObject *obj,const Vector3 &v)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	GameObject *o = As_ScriptZoneGameObj(obj);
+	GameObject *o = obj->As_ScriptZoneGameObj();
 	if (!o)
 	{
 		return false;
@@ -449,16 +461,16 @@
 
 bool SCRIPTS_API IsInsideZone(GameObject *zone,GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	if (!Commands->Get_ID(zone) || !zone)
+	if (!zone)
 	{
 		return false;
 	}
-	GameObject *o = As_SmartGameObj(obj);
-	GameObject *o2 = As_ScriptZoneGameObj(zone);
+	GameObject *o = obj->As_SmartGameObj();
+	GameObject *o2 = zone->As_ScriptZoneGameObj();
 	if ((o) && (o2))
 	{
 		Vector3 v;
@@ -477,26 +489,26 @@
 
 unsigned int SCRIPTS_API Get_Zone_Type(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	GameObject *o = As_ScriptZoneGameObj(obj);
+	ScriptZoneGameObj *o = obj->As_ScriptZoneGameObj();
 	if (!o)
 	{
 		return 0;
 	}
-	ScriptZoneGameObjDef *d = (ScriptZoneGameObjDef *)Get_Definition(obj);
+	const ScriptZoneGameObjDef *d = &o->Get_Definition();
 	return d->Get_Type();
 }
 
 void SCRIPTS_API Set_Zone_Box(GameObject *obj,OBBoxClass &box)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	ScriptZoneGameObj *o = (ScriptZoneGameObj*)As_ScriptZoneGameObj(obj);
+	ScriptZoneGameObj *o = obj->As_ScriptZoneGameObj();
 	if (!o)
 	{
 		return;
@@ -508,27 +520,30 @@
 {
 	GameObject *obj = Create_Library_Object(preset);
 	Set_Zone_Box(obj,box);
-	((ScriptableGameObj *)obj)->Start_Observers();
+	obj->Start_Observers();
 	return obj;
 }
 
 void SCRIPTS_API Set_Vehicle_Is_Visible(GameObject *obj,bool visible)
 {
-	if(!Is_Vehicle(obj))
+	if(!obj)
 	{
 		return;
 	}
-	VehicleGameObj *b = (VehicleGameObj *)obj;
+	VehicleGameObj *b = obj->As_VehicleGameObj();
+	if (b)
+	{
 	b->Set_Is_Scripts_Visible(visible);
 }
+}
 
 void SCRIPTS_API Set_Vehicle_Gunner(GameObject *obj,int seat)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	if (seat <= 1 || seat > o->Get_Definition().Get_Seat_Count())
 	{
 		return;
@@ -541,7 +556,7 @@
 	}
 }
 
-bool SmartGameObj::Is_Stealthed() const
+SCRIPTS_API bool SmartGameObj::Is_Stealthed() const
 {
    if (StealthEffect)
    {
@@ -553,7 +568,7 @@
    return false;
 }
 
-bool SmartGameObj::Is_Human_Controlled()
+SCRIPTS_API bool SmartGameObj::Is_Human_Controlled()
 {
    return (this->ControlOwner >= 0);
 }
@@ -583,34 +598,29 @@
 	return Get_Driver();
 }
 
-const VehicleGameObjDef & VehicleGameObj::Get_Definition( void ) const
+SCRIPTS_API const VehicleGameObjDef & VehicleGameObj::Get_Definition( void ) const
 {
 	return (const VehicleGameObjDef &)BaseGameObj::Get_Definition();
 }
 
 // 0x006802B0, 0x0067FB50, 0x, 0x0810D93A
-SmartGameObj* GameObjManager::Find_SmartGameObj
-   (int networkId)
+SCRIPTS_API SmartGameObj* GameObjManager::Find_SmartGameObj(int networkId)
 {
    if (!networkId)
       return 0;
-
    for (SLNode<SmartGameObj>* node = GameObjManager::SmartGameObjList.Head(); node; node = node->Next())
    {
 	  SmartGameObj* object = (SmartGameObj *)node->Data();
       if (object->Get_Network_ID() != networkId)
          continue;
-
 	  if (object->Is_Delete_Pending())
          return 0;
-
       return object;
    }
-
    return 0;
 }
 
-bool SmartGameObj::Has_Player()
+SCRIPTS_API bool SmartGameObj::Has_Player()
 {
 	return ControlOwner != SERVER_CONTROL_OWNER;
 }
@@ -620,7 +630,7 @@
 	return StealthEnabled;
 }
 
-bool SmartGameObj::Is_Obj_Visible(PhysicalGameObj* object)
+SCRIPTS_API bool SmartGameObj::Is_Obj_Visible(PhysicalGameObj* object)
 {
 	const Vector3 bullseyePosition = object->Get_Bullseye_Position();
 	const Matrix3D lookTransform = Get_Look_Transform();
@@ -650,7 +660,7 @@
 		collisionTest.CollidedPhysObj == object->Peek_Physical_Object();
 }
 
-const SmartGameObjDef & SmartGameObj::Get_Definition( void ) const
+SCRIPTS_API const SmartGameObjDef & SmartGameObj::Get_Definition( void ) const
 {
 	return (const SmartGameObjDef &)BaseGameObj::Get_Definition();
 }
@@ -662,11 +672,64 @@
 
 bool SCRIPTS_API Is_Spy(GameObject *obj)
 {
-	if (obj->As_SoldierGameObj())
+	if (obj && obj->As_SoldierGameObj())
 	{
 		return obj->As_SoldierGameObj()->Get_Definition().Is_Spy();
 	}
 	return false;
 }
 
+SCRIPTS_API bool Is_Stealth_Enabled(GameObject *obj)
+{
+	if (obj && obj->As_SoldierGameObj())
+	{
+		return obj->As_SoldierGameObj()->Is_Stealth_Enabled();
+	}
+	return false;
+}
+
+SCRIPTS_API int Get_Object_Count_In_Zone(GameObject *obj,int Team)
+{
+		if (!obj)
+		{
+				return 0;
+		}
+		ScriptZoneGameObj *Zone = obj->As_ScriptZoneGameObj();
+		if (!Zone)
+		{
+				return 0;
+		}
+		int Return = 0;
+		for (SLNode<SmartGameObj> *z = GameObjManager::SmartGameObjList.Head();z;z = z->Next())
+		{
+				if ((Get_Object_Type(z->Data()) == Team || Team == 2) && Zone->Inside_Me(z->Data()))
+				{
+						Return++;
+				}
+		}
+		return Return;
+}
+
+SCRIPTS_API int Get_Player_Count_In_Zone(GameObject *obj,int Team)
+{
+		if (!obj)
+		{
+				return 0;
+		}
+		ScriptZoneGameObj *Zone = obj->As_ScriptZoneGameObj();
+		if (!Zone)
+		{
+				return 0;
+		}
+		int Return = 0;
+		for (SLNode<SoldierGameObj> *z = GameObjManager::StarGameObjList.Head();z;z = z->Next())
+		{
+				if ((Get_Object_Type(z->Data()) == Team || Team == 2) && Zone->Inside_Me(z->Data()))
+				{
+						Return++;
+				}
+		}
+		return Return;
+}
+
 REF_DEF2(SmartGameObj::GlobalSightRangeScale,float,0x00811E64,0x0081103C);
diff -uwr sourceold/scripts/engine_obj2.h source/scripts/engine_obj2.h
--- sourceold/scripts/engine_obj2.h	2012-02-13 18:26:42.432039000 +0800
+++ source/scripts/engine_obj2.h	2012-05-23 11:26:18.001953100 +0800
@@ -48,4 +48,7 @@
 void SCRIPTS_API Set_Vehicle_Is_Visible(GameObject *obj,bool visible); //works like Set_Is_Visible but for vehicles, makes them be ignored by Enemy_Seen
 void SCRIPTS_API Set_Vehicle_Gunner(GameObject *obj,int seat); //set gunner for this vehicle
 bool SCRIPTS_API Is_Spy(GameObject *obj); //Is this soldier object a spy
+SCRIPTS_API int Get_Player_Count_In_Zone(GameObject *obj,int Team); //Get the player count in a zone
+SCRIPTS_API int Get_Object_Count_In_Zone(GameObject *obj,int Team); //Get the object count in a zone
+SCRIPTS_API bool Is_Stealth_Enabled(GameObject *obj); //Is stealth enabled
 #endif
